TEMPER_L	EQU	36H	;存放温度低位数据
TEMPER_H	EQU	35H	;存放温度高位数据
TEMPER	EQU	34H	;存放转换后的温度值
TEMPER_NUM	EQU	60H	;缓冲单元
WSLA	EQU	070H	;ZLG7290B 口地址
RSLA	EQU	071H	
DISDA	EQU	20H	;读出温度的字形码存储
DISCON	EQU	08H	;送入ZLG7290B数据个数

BELLNUM	EQU	49H	;存放响铃上限数据
BELLLOW	EQU	59H	;存放响铃下限数据
TONE	BIT	01H	;高低位报警标志位

FLAG1	BIT	00H	;20H 单元中的最低位
DQ	BIT	P3.3	;DS18B20控制端口
SDA	BIT	P1.0	;ZLG7290B 的引脚定义
SCL	BIT	P1.1	
ORG	0000H	;复位向量地址
LJMP	MAIN	
ORG	0003H	;INT0 中断入口地址
LJMP	INT_7290	
ORG	0100H	;主程序起始地址

MAIN:	MOV	SP,#70H	
MOV	TMOD,#10H	;设 T1 为方式 1
MOV	TL1,#33H;定时器1赋初值控制扬声器
MOV	TH1,#0FEH	
;11.0592 MHz/12 = 921.6 kHz
;65536 - 921.6 = 64614
SETB	TR1	;启动 T1
MOV	42H,#00H;42H~47H中的数据清零
MOV	43H,#00H;为存储响铃上限字形码
MOV	44H,#00H	
MOV	45H,#00H	
MOV	46H,#00H	
MOV	47H,#00H	
MOV	52H,#00H; 52H~57H中的数据清零
MOV	53H,#00H;为存储响铃下限字形码
MOV	54H,#00H
MOV	55H,#00H
MOV	56H,#00H
MOV	57H,#00H

MOV	BELLNUM,#20H ;设定默认报警温度上限
MOV	BELLLOW,#15H ;设定默认报警温度下限

CLR	P1.7	;ZLG7290B 复位
LCALL	DELAY
SETB	P1.7
SETB	EX0	;开外部中断 INT0
SETB	EA	;开总中断
SETB	IT0	;设定触发方式为下降沿触发

LP1:	;主循环
MOV	A,BELLNUM
LCALL	CF	;将频率上限进行拆分
MOV	40H,R3	;对存频率上限的字形码
MOV	41H,R4  ;3低4高
MOV	A,BELLLOW
LCALL	CF	;将频率下限进行拆分
MOV	50H,R3	;对频率下限的字形码存入 50H、51H 单元
MOV	51H,R4

LCALL	GET_TEMPER	;从 DS18B20 读出温度数据
LCALL	TEMPER_COV	;转换读出的温度数据并保存
MOV	A,TEMPER
LCALL	GAOWEI	;对温度整数部分的高位部分进行转换
LCALL	CF
MOV	26H,R3	;高位字形码存入 26H、27H 单元中
MOV	27H,R4
MOV	A,TEMPER
LCALL	TOBCD	;将温度的整数的低两位部分转换为 BCD 码
CJNE	A,BELLNUM,NEXT3	;将温度值与报警上限进行比较
NEXT3:  JC	NEXT5	;若比上限温度小则转而与温度下限进行比较
NEXT4:  SETB	TONE		;达到温度上限置 TONE 为 1
LCALL	RING	;蜂鸣器响
SJMP	NEXT8
NEXT5:	CJNE	A,BELLLOW,NEXT7	;将温度值与报警下限进行比较
NEXT7:	JNC	NEXT8	
CLR	TONE	;若小于温度下限值，则置 TONE 为 0
LCALL	RING	;蜂鸣器响
NEXT8:	
LCALL	CF	
INC	R3	;加上小数点字形码
MOV	24H,R3	;
MOV	25H,R4	
LCALL	XIAOSHUDI	;显示小数位低两位码
MOV	20H,R3	;20H、21H 存放小数部分低两位的字形
MOV	21H,R4	
LCALL	XIAOSHUGAO;显示小数位高两位码
MOV	22H,R3	;
MOV	23H,R4	
MOV	R7,#DISCON	;ZLG7290B 显示温度值
MOV	R2,#10H	
MOV	R3,#WSLA	
MOV	R0,#DISDA
JNB	P1.2,BELL	;判断 sw1 是否按下
JNB	P1.3,BELOW	;判断 sw2 是否按下
SJMP	NEXT6	
BELL:	MOV	47H,#2EH	;最高位显示 h
MOV	R0,#40H	;显示温度报警上限值
SJMP	NEXT6	
BELOW:	MOV	57H,#1CH	;最高位显示 L
MOV	R0,#50H	;显示温度报警下限值
NEXT6:	LCALL	WRNBYT	
LCALL	DELAY	
SJMP	LP1	;主程序循环
;主程序结束
;************************************
;读出转换后的温度
GET_TEMPER:;
	SETB	DQ;
BCD:	
	LCALL	INIT_1820;初始化DS18B20
	JB		FLAG1,S22
	LJMP	BCD;若DS18B20不存在返回
S22:	
	LCALL	DELAY1
	MOV	A,#0CCH;跳过ROM匹配0CCH
	LCALL	WRITE_1820
	MOV	A,#44H;发出温度转换命令
	LCALL	WRITE_1820
	LCALL	DELAY
CBA:	
	LCALL	INIT_1820
	JB		FLAG1,ABC
	LJMP	CBA
ABC:	
	LCALL	DELAY1
	MOV	A,#0CCH;跳过ROM匹配
	LCALL	WRITE_1820
	MOV	A,#0BEH;发出读温度命令
	LCALL	WRITE_1820
	LCALL	READ_1820
	RET

WRITE_1820:	
	MOV	R2,#8;写入8位数据
	CLR	C
WR1:	
	CLR	DQ;DQ置0表示写入数据
	MOV	R3,#7;延时15μs
	DJNZ	R3,$
	RRC	A
	MOV	DQ,C
	MOV	R3,#15H;延时45μs
	DJNZ	R3,$
	SETB	DQ;一个周期至少要维持60μs
	NOP;离下一个写周期至少要有1μs的时间间隔
	DJNZ	R2,WR1
	SETB	DQ
	RET

READ_1820:；从DS18B20读取两个字节的温度数据
	PUSH	02H
	PUSH	04H
	MOV	R4,#2;将温度高低位读出
	MOV	R1,#36H;低位36H，高位35H
RE00: 
	MOV	R2,#8H
RE01:	
	CLR	C
	SETB	DQ
	NOP
	CLR	DQ;DQ=0,15μs内DS18B20送数
	NOP
	NOP
	NOP
	NOP
	NOP;共延时5μs
	SETB	DQ;主控器释放DQ
	MOV	R3,#5
	DJNZ	R3,$;延时10μs
	MOV	C,DQ;取DQ数据位
	MOV	R3,#1CH;延时60μs
	DJNZ	R3,$
	RRC	A
	DJNZ	R2,RE01
	MOV	@R1,A
	DEC	R1
	DJNZ	R4,RE00
	POP	04H
	POP	02H
	RET
TEMPER_COV:
	MOV	A,#0F0H
	ANL	A,TEMPER_L;舍去小数点后4位
	SWAP	A
	MOV	TEMPER_NUM,A
	MOV	A,TEMPER_L
	JNB	ACC.3,TEMPER_COV1;四舍五入
	INC	TEMPER_NUM

TEMPER_COV1:
	MOV	A,TEMPER_H
	ANL	A,#07H
	SWAP	A
	ADD	A,TEMPER_NUM
	MOV	TEMPER_NUM,A;保存变换后的数据
	MOV	TEMPER,TEMPER_NUM
	RET

INIT_1820:	;初始化
	SETB	DQ
	NOP
	CLR	DQ
	MOV	R0,#0ECH
TSR1:	
	DJNZ	R0,TSR1;延时500μs
	SETB	DQ
	MOV	R0,#1CH;延时60μs
TSR2:
	DJNZ	R0,TSR2
	JNB	DQ,TSR3
	LJMP	TSR4
TSR3:	
	SETB	FLAG1;置标志位
	LJMP	TSR5;DS18B20存在
TSR4:	
	CLR	FLAG1;清标志位
	LJMP	TSR7;DS18B20不存在
TSR5:
	MOV	R0,#0E0H;224
TSR6:
	DJNZ	R0,TSR6;延时500μs
TSR7:	
	SETB	DQ
	RET

DELAY1: MOV	R7,#20H	;;延时80μs
DJNZ	R7,$
DELAY:	RET
PUSH 00H
PUSH 01H
	MOV	R0,#00
LP:	MOV	R1,#00H
	DJNZ	R1,$
	DJNZ	R0,LP
	POP	01H
	POP	00H
	RET	
;**********************************
;小数低位字型码存储
XIAOSHUDI:		;显示小数低位
PUSH	02H	
PUSH	DPH	
PUSH	DPL	
MOV	DPTR, #XIAODI	
MOV	A,#0FH	
ANL	A,TEMPER_L	;获取小数位
MOV	R2, A	
MOVC	A, @A+DPTR	;查表得小数低位
LCALL	CF	
POP	DPL	
POP	DPH	
POP	02H	
RET		
;小数高位字型码存储
XIAOSHUGAO:		;显示小数高位
PUSH	02H	
PUSH	DPH	
PUSH	DPL	
MOV	DPTR, #XIAOGAO	
MOV	A,#0FH	
ANL	A,TEMPER_L	;获取小数位
MOV	R2, A	
MOVC	A, @A+DPTR	;查表得小数高位
LCALL	CF	
POP	DPL	
POP	DPH	
POP	02H	
RET		
;***********************************
;拆分
CF:	PUSH	02H	
	PUSH	DPH	
	PUSH	DPL	
	MOV	DPTR, #LEDSEG	;查找字符表
	MOV	R2, A	
	ANL	A, #0FH	;00001111，清高四位
	MOVC	A, @A+DPTR	
	MOV	R3, A	;低四位字形码送入 R3
	MOV	A, R2	
	SWAP	A	;交换高低四位
	ANL	A, #0FH	;处理高四位
	MOVC	A, @A+DPTR	
	MOV	R4, A	;高四位字形码送入 R4
	POP	DPL	
	POP	DPH	
	POP	02H	
	RET	
;**********************************	
;二进制转为BCD
TOBCD: PUSH	00H	
PUSH	03H	
PUSH	02H	
PUSH	07H	
MOV	R7,#08	;确定移位 8 次
MOV	R2,A	;将 A 值送入 R2
MOV	R0,#00H	
TOBCD1:RLC	A	;将 A 左移一位
XCH	A,R0	
MOV	R3,A	
 
ADDC	A,R3	;将进位位加到 R3 中
DA	A	;进行 BCD 调整
XCH	A,R0	
DJNZ	R7,TOBCD1	;移位 8 次
MOV	A,R0	;将转换后的结果送入 A 中
POP	07H	
POP	02H	
POP	03H	
POP	00H	
RET		
;************************************
;温度的最高位进行处理 
GAOWEI:
CJNE	A,#100,GAOWEI1 
GAOWEI1:	MOV	A,#00H
JC	GAOWEI2
INC	A	;转换后的结果如果比 100 大，最高位置 1 
GAOWEI2:	RET
;************************************
;响铃
RING:	PUSH	PSW	
	MOV	R6,#00H	
RING1:	JNB	TF1,$	;判断时间是否到
	CLR	TF1	;清位
	JB	TONE,RING2	
	MOV	TL1,#033H	;赋初值（低频）
	MOV	TH1,#0FAH	
	AJMP	RING3	
RING2:	MOV	TL1,#033H	;赋初值（高频）
	MOV	TH1,#0FEH	
RING3:	CPL	P3.5	;响铃
	DJNZ	R6,RING1	
	POP	PSW	
	RET		
;************************************
;键盘修改
INT_7290:
PUSH	00H
PUSH	02H
PUSH	03H
PUSH	04H
PUSH	07H
PUSH	ACC
PUSH	PSW
LCALL	RDKEY	;读取第一个按键值
CJNE	R3,#060H,LOWNUM	;判断是1 键
AJMP	UPPER	;跳转到报警上限值显示
LOWNUM:CJNE	R3,#0DAH,DOWN;判断是2 键
AJMP	LOWER	;跳转到报警下限值显示
UPPER:		
	JNB	P1.2,BELL1	;判断sw1是否按下
	JNB	P1.3,BELOW1;判断 sw2 是否按下	
	AJMP	DOWN
BELL1:	
	MOV	A,BELLNUM
	INC A
	DA A
	MOV       BELLNUM,A
	SJMP	NEXT11	
BELOW1:	
	MOV	A,BELLLOW
	INC A
	DA A
	MOV       BELLLOW,A
NEXT11:AJMP	DOWN	;退出中断
LOWER:	
	JNB	P1.2,BELL2	;判断sw1是否按下
	JNB	P1.3,BELOW2;判断sw2是否按下	
	AJMP	DOWN
BELL2:	
	MOV	A,BELLNUM
	ANL A,#0FH
	CJNE A,#00H,ABC1
	MOV	A,BELLNUM
    SUBB A,#07H
	MOV	BELLNUM,A
	SJMP	NEXT12	
ABC1:	MOV	A,BELLNUM
	DEC         A
	MOV	BELLNUM,A
	DA A
	SJMP	NEXT12	
BELOW2:	
	MOV	A,BELLLOW
	ANL A,#0FH
	CJNE A,#00H,DEF
	MOV	A,BELLLOW
        SUBB A,#07H
	MOV	BELLLOW,A
	SJMP	NEXT12	
DEF:	MOV	A,BELLLOW
	DEC         A
	DA A
	MOV	BELLLOW,A
NEXT12:	
DOWN:	
CLR IE0	;清位
	POP	PSW	
	POP	ACC	
	POP	07H	
	POP	04H	
	POP	03H	
	POP	02H	
	POP	00H	
	RETI		
;读键值子程序
RDKEY:	MOV	R0,#48H	
	MOV	R7,#01H	;取一个数据
	MOV	R2,#01H	
	MOV	R3,#WSLA	;取数据地址（写）
	MOV	R4,#RSLA	;取数据地址（读）
	LCALL	RDNBYT	
	NOP		
	MOV	A,48H
	LCALL	CF	;将频率下限进行拆分	
	RET		
;字符表
LEDSEG:
DB 0FCH,60H,0DAH,0F2H,66H,0B6H,0BEH,0E4H ;存放 0~F 的字形码
DB	0FEH,0F6H,0EEH,3EH,9CH,7AH,9EH,8EH;存放小数位的查表结果
XIAODI: 
DB 00H,25H,50H,75H,00H,25H,50H,75H,00H,25H,50H,75H,00H,25H,50H,75H 
XIAOGAO:DB 00H,06H,12H,18H,25H,31H,37H,43H,50H,56H,62H,68H,75H,81H,87H,93H
;*************I2C相关程序************
;(1)WRNBYT
;相关子程序 WRBYT STOP, CACK, STA
WRNBYT: PUSH PSW
PUSH ACC
WRADD: MOV A,R3 ;取外围器件地址（包含 R/W 位）
LCALL STA ;发送起始信号 S
LCALL WRBYT ;发送外围地址
LCALL CACK ;检测外围器件的应答信号
JB F0,WRADD ;如果应答不正确返回
MOV A,R2 ;发送内部寄存器首地址
LCALL WRBYT ;发送外围地址
LCALL CACK ;检测外围器件的应答信号
JB F0,WRADD ;如果应答不正确返回
WRDA: MOV A,@R0
LCALL WRBYT ;发送外围地址
LCALL CACK ;检测外围器件的应答信号
JB F0,WRADD ;如果应答不正确返回
INC R0
DJNZ R7,WRDA
LCALL STOP
POP ACC
POP PSW
RET

;(2)RDNBYT
;相关子程序 WRBYT, STOP, CACK, STA, MNACK,RDBYT
RDNBYT: PUSH PSW
PUSH ACC
RDADD1: LCALL STA ;取器件地址（写）
MOV A,R3 ;发送外围地址
LCALL WRBYT

LCALL CACK ;检测外围器件的应答信号
JB F0,RDADD1 ;如果应答不正确返回
MOV A,R2 ;取内部地址
LCALL WRBYT ;发送外围地址
LCALL CACK ;检测外围器件的应答信号
JB F0,RDADD1 ;如果应答不正确返回
LCALL STA ;取器件地址（读）
MOV A,R4 ;发送外围地址
LCALL WRBYT ;发送外围地址
LCALL CACK ;检测外围器件的应答信号
JB F0,RDADD1 ;如果应答不正确返回
RDN: LCALL RDBYT
MOV @R0,A
DJNZ R7,ACK
LCALL MNACK
LCALL STOP
POP ACC
POP PSW
RET
ACK: LCALL MACK
INC R0
SJMP RDN

;(3) I2C总线各个信号子程序
;启动信号子程序STA
STA: SETB SDA ;启动信号 S
SETB SCL
NOP ;产生 4.7us 延时
NOP
NOP
NOP
NOP
CLR SDA ;产生 4.7us 延时
NOP
NOP
NOP
NOP
NOP
CLR SCL
RET

; 停止信号子程序 STOP

STOP: CLR SDA ;停止信号 P
SETB SCL ;产生 4.7us 延时
NOP
NOP
NOP
NOP
NOP
SETB SDA ;产生 4.7us 延时
NOP
NOP
NOP
NOP
NOP
CLR SCL ;释放总线
SETB SDA
RET

; 应答信号子程序 MACK
MACK: CLR SDA ;发送应答信号 ACK
SETB SCL ;产生 4.7us 延时
NOP
NOP
NOP
NOP
NOP
CLR SCL
SETB SDA
RET

; 非应答信号子程序 MNACK
MNACK: SETB SDA ;发送非应答信号 NACK
SETB SCL ;产生 4.7us 延时
NOP
NOP
NOP
NOP
NOP
CLR SCL
CLR SDA
RET
; 应答位检测子程序 CACK
CACK: SETB SDA ;采样 SDA
SETB SCL
CLR F0
MOV C,SDA ;应答正确时转 CEND
JNC CEND
SETB F0 ;应答错误时 F0 置 1
CEND: CLR SCL
RET

; 发送 1 个字节子程序 WRBYT
WRBYT: PUSH 06H ;发送 1 个字节子程序
MOV R6,#08H ;入口参数 A
WLP: RLC A ;产生 4.7us 延时
MOV SDA,C
SETB SCL
NOP
NOP
NOP
NOP
NOP
JNB SCL,$
CLR SCL
DJNZ R6,WLP
POP 06H
RET

; 接收 1 个字节子程序 RDBYT
RDBYT: PUSH 06H ;接收 1 个字节子程序，出口参数 R2
MOV R6,#08H
RLP: SETB SDA
SETB SCL
JNB SCL,$
MOV C,SDA
MOV A,R2
RLC A
MOV R2,A
CLR SCL
DJNZ R6,RLP
POP 06H
RET

END